#pragma GCC optimize("Ofast", "unroll-loops")

#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define all(a) a.begin(), a.end()

const int N = 2e5 + 10, K = 18;
vector<int> g[N];
int tin[N], tout[N], rev[N], cnt = 0;
int dep[N];
int po[K][N];

void zhfs(int v, int p) {
    rev[cnt] = v;
    tin[v] = cnt++;
    for (auto u : g[v]) {
        if (u != p) {
            po[0][u] = v;
            dep[u] = dep[v] + 1;
            zhfs(u, v);
        }
    }
    tout[v] = cnt - 1;
}

pair<int, int> t[4 * N];
int add[4 * N];

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = make_pair(dep[rev[l]], rev[l]);
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m), build(2 * v + 1, m + 1, r);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

void inc(int v, int val) {
    t[v].first += val;
    add[v] += val;
}

void push(int v) {
    inc(v * 2, add[v]);
    inc(v * 2 + 1, add[v]);
    add[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, int val) {
    if (l > r) return;
    if (tl == l && tr == r) {
        inc(v, val);
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int n, k, type;
int ans[N];

bool is_parent(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int kth_parent(int v, int k) {
    for (int i = K - 1; i >= 0; i--) {
        if (k & (1 << i)) {
            v = po[i][v];
        }
    }
    return v;
}

int lca(int a, int b) {
    if (dep[a] > dep[b]) {
        swap(a, b);
    }
    if (is_parent(a, b)) {
        return a;
    }
    for (int i = K - 1; i >= 0; i--) {
        int v = po[i][b];
        if (!is_parent(v, a)) {
            b = v;
        }
    }
    return po[0][b];
}

array<int, 3> rem[2 * N];

void dfs(int v, int p) {
    int l = max(0, t[1].first / (k + 1) - 1), r = t[1].first;
    while (r - l > 1) {
        int mid = (r + l) / 2, kek = 0;
        int ind = 0;
        auto del = [&](int l, int r, int val) -> void {
            rem[ind++] = {l, r, val};
            update(1, 0, n - 1, l, r, -val);
        };
        while (kek <= k && t[1].first > mid) {
            int vert = t[1].second;
            kek++;
            if (kek > k) break;
            if (is_parent(v, vert)) {
                int u = kth_parent(vert, mid - 1);
                del(tin[u], tout[u], n);
            } else if (is_parent(vert, v)) {
                int u = kth_parent(v, (dep[v] - dep[vert]) - mid);
                del(0, tin[u] - 1, n);
                del(tout[u] + 1, n - 1, n);
            } else {
                int g = lca(v, vert);
                if (dep[vert] - dep[g] > mid - 1) {
                    int u = kth_parent(vert, mid - 1);
                    del(tin[u], tout[u], n);
                } else {
                    int len = (mid - 1) - (dep[vert] - dep[g]);
                    int u = kth_parent(v, (dep[v] - dep[g]) - len - 1);
                    del(0, tin[u] - 1, n);
                    del(tout[u] + 1, n - 1, n);
                }
            }
        }
        if (kek <= k) {
            r = mid;
        } else {
            l = mid;
        }
        for (int i = 0; i < ind; i++) {
            update(1, 0, n - 1, rem[i][0], rem[i][1], rem[i][2]);
        }
    }
    ans[v] = r;
    for (auto u : g[v]) {
        if (u != p) {
            inc(1, 1);
            update(1, 0, n - 1, tin[u], tout[u], -2);
            dfs(u, v);
            update(1, 0, n - 1, tin[u], tout[u], 2);
            inc(1, -1);
        }
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k >> type;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].pb(b);
        g[b].pb(a);
    }
    zhfs(0, -1);
    build(1, 0, n - 1);
    for (int i = 1; i < K; i++) {
        for (int j = 0; j < n; j++) {
            po[i][j] = po[i - 1][po[i - 1][j]];
        }
    }
    dfs(0, -1);
    if (type == 0) {
        cout << ans[0] << endl;
    } else {
        for (int i = 0; i < n; i++) {
            cout << ans[i] << ' ';
        }
        cout << endl;
    }
    return 0;
}
