#include<bits/stdc++.h>

#define ll long long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

using namespace std;

const int N = 1e5 + 10, K = 2010, L = 52;
int l[N], r[N], par[N];
int sz[N];
bool spec[N];

int zhfs(int v, int p) {
    sz[v] = 1;
    int dep = 0;
    if (l[v] != -1) {
        dep = max(dep, zhfs(l[v], v) + 1);
        sz[v] += sz[l[v]];
        par[l[v]] = v;
    }
    if (r[v] != -1) {
        dep = max(dep, zhfs(r[v], v) + 1);
        sz[v] += sz[r[v]];
        par[r[v]] = v;
    }
    if (dep > K) {
        spec[v] = 1;
        dep = 0;
    }
    return dep;
}

int arr[N][3];
int t[4 * N][L][4], type[4 * N];

int number[N];
int layer = 0;

void build(int v, int l, int r, int cur) {
    if (l == r) {
        t[v][cur][0] = t[v][cur][1] = arr[l][0];
        t[v][cur][1] = arr[l][1];
        t[v][cur][2] = arr[l][2];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m, cur), build(2 * v + 1, m + 1, r, cur);
    t[v][cur][0] = t[v * 2][cur][0] + t[v * 2 + 1][cur][0];
}

int n, q;

void dfs(int v, int p) {
    if (spec[v]) {
        number[v] = layer;
        build(1, 0, n - 1, layer);
        layer++;
    }
    int L = 0;
    if (l[v] != -1) {
        L = sz[l[v]];
        arr[v][0] = 1;
        arr[v][1] = arr[v][2] = 0;
        dfs(l[v], v);
    }
    if (r[v] != -1) {
        arr[v][0] = 1 + L;
        arr[v][1] = 1 + L;
        arr[v][2] = L;
        dfs(r[v], v);
    }
}

void upd(int v, int val, int cur) {
    t[v][cur][0] = t[v][cur][val];
    type[v] = val;
}

void push(int v) {
    if (type[v] != -1) {
        for (int i = 0; i < layer; i++) {
            upd(2 * v, type[v], i);
            upd(2 * v + 1, type[v], i);
        }
    }
    type[v] = -1;
}

void update(int v, int tl, int tr, int l, int r, int val) {
    if (l > r) return;
    if (tl == l && tr == r) {
        for (int i = 0; i < layer; i++) {
            upd(v, val, i);
        }
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
    for (int i = 0; i < layer; i++) {
        t[v][i][0] = t[v * 2][i][0] + t[v * 2 + 1][i][0];
    }
}

const int DIFK = 400;
int a[N], block_type[(N / DIFK) + 5];

void clean(int i) {
    if (block_type[i] != -1) {
        for (int j = i * DIFK; j < (i + 1) * DIFK; j++) {
            a[j] = block_type[i];
        }
        block_type[i] = -1;
    }
}

void update_on_seg(int l, int r, int x) {
    int l1 = l / DIFK, r1 = r / DIFK;
    if (l1 == r1) {
        clean(l1);
        for (int i = l; i <= r; i++) {
            a[i] = x;
        }
    } else {
        for (int j = l1 + 1; j <= r1 - 1; j++) {
            block_type[j] = x;
        }
        clean(l1), clean(r1);
        for (int j = l; j < (l1 + 1) * DIFK; j++) {
            a[j] = x;
        }
        for (int j = r1 * DIFK; j <= r; j++) {
            a[j] = x;
        }
    }
}

int get_type(int i) {
    int block = i / DIFK;
    if (block_type[block] != -1) {
        return block_type[block];
    } else {
        return a[i];
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 0; i < 4 * N; i++) {
        type[i] = -1;
    }
    for (int i = 0; i < N / DIFK; i++) {
        block_type[i] = -1;
    }
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        l[i]--, r[i]--;
    }
    zhfs(0, -1);
    //dfs(0, -1);
    for (int i = 0; i < n; i++) {
        spec[i] = 0;
    }
    for (int i = 0; i < q; i++) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            l--, r--;
            x++;
            update_on_seg(l, r, x);
            update(1, 0, n - 1, l, r, x);
        } else {
            int v;
            cin >> v;
            v--;
            int ans = 1;
            int type = get_type(v);
            if (type > 0) {
                if (l[v] != -1) {
                    ans += sz[l[v]];
                }
            }
            if (type == 2) {
                if (r[v] != -1) {
                    ans += sz[r[v]];
                }
            }
            if (!spec[v]) {
                while (v != 0 && !spec[v]) {
                    int u = par[v];
                    int type = get_type(u);
                    if (l[u] == v) {
                        if (type == 0) {
                            ans++;
                        }
                    } else {
                        if (l[u] != -1) {
                            ans += sz[l[u]];
                        }
                        if (type != 2) {
                            ans++;
                        }
                    }
                    v = u;
                }
            } else {
                ans += t[1][number[v]][0];
            }
            cout << ans << '\n';
        }
    }
    return 0;
}
